// calc_var.cpp: implementation of the calc_var class.
//
//////////////////////////////////////////////////////////////////////
//   .       
//       .
#include "stdafx.h"
#include "calc_var.h"




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

calc_var::calc_var()
{
	memset(Function,0,256);
	pCurrPos=Function;
	ClearVars();// 

}

calc_var::~calc_var()
{

}

calc_var::calc_var(char *lpszFunction)
{
	SetFunction(lpszFunction);
	ClearVars();
}

void calc_var::ClearVars()
{
	memset(variables,0,sizeof(double)*27);
}

double calc_var::prim()
{
	GetToken();
	switch(CurrTok)
	{
	case NUMBER:
		{
			double temp=atof(TokenValue);
			GetToken();
			return temp;
		}
	case VARIABLE:
		{
			char c=*TokenValue;/*    */
			if(*pCurrPos=='=')
			{
				*pCurrPos++;// ,        '=' 
				variables[c-'A']=add_sub();
			}
			GetToken();
			return variables[c-'A'];
		}
	case OPERATOR:
		{
			switch(*TokenValue)
			{
				case '-':return -prim();
				case '+':return prim();
				case '(':
					{
						double temp=add_sub();
						if(*TokenValue!=')') throw(SyntaxError(") expected"));
						GetToken();
						return temp;
					}
			}//end switch(TokenValue)
			throw(SyntaxError("Incorrect operator"));
		}//end case OPERATOR
	case FUNC:
		{
	
			if(strcmp(TokenValue,"pi")==0){GetToken(); return 3.1415926535;}
			if(strcmp(TokenValue,"abs")==0)return fabs(prim());
			if(strcmp(TokenValue,"sin")==0)return sin(prim());
			if(strcmp(TokenValue,"cos")==0)return cos(prim());
			if(strcmp(TokenValue,"tg")==0)//
			{
				double angle=prim();
				double temp= cos(angle);
				if(temp==0) throw(MathError("can't calculate tg"));
				return sin(angle)/temp;

			}
			if (strcmp(TokenValue,"ctg")==0)
			{
				double angle=prim();
				double temp= sin(angle);
				if(temp==0) throw(MathError("can't calculate tg"));
				return cos(angle)/temp;

			}
			if (strcmp(TokenValue,"ln")==0)
			{
				double temp=prim();
				if(temp<=0) throw(MathError("argument of lg is <= zero"));
				return log(temp);
			}
			if (strcmp(TokenValue,"exp")==0) return exp(prim());
			if (strcmp(TokenValue,"asin")==0)
			{
				double temp=prim();
				if(temp<-1||temp>1)throw(MathError("argument of asin is out of ranges"));
				return asin(temp);
			}
			if (strcmp(TokenValue,"acos")==0)
			{
				double temp=prim();
				if(temp<-1||temp>1)throw(MathError("argument of acos is out of ranges"));
				return acos(temp);
			}
			throw(SyntaxError("Incorrect function"));
		}
	case PRINT://   ( ;
	case END: return 0;
	default:throw(SyntaxError("No Expression"));
	}

}

void calc_var::GetToken()
{
	if((!pCurrPos)||(!*pCurrPos)){ CurrTok=END; *TokenValue=0; return;}// 
	while((*pCurrPos==' ')||(*pCurrPos=='\n')||(*pCurrPos=='\r'))pCurrPos++;//   
//	TokenValue=UNDEF; // 
	
	char* temp=TokenValue;
	if(isdigit(*pCurrPos))
	{
		CurrTok=NUMBER;
		while(isdigit(*pCurrPos)||(*pCurrPos=='.'))*temp++=*pCurrPos++;
//		*temp=0;

	}
	else if(strchr("+-*/%^()",*pCurrPos))
	{
		CurrTok=OPERATOR;
		//   
		*temp++=*pCurrPos++;//  TokenValue 
//		*temp=0;
	}
	else if(islower(*pCurrPos))//  .      
	{
		while(islower(*pCurrPos))*temp++=*pCurrPos++;
		CurrTok=FUNC;
	}
	else if(isupper(*pCurrPos))//  .      .    
	{
		while(isupper(*pCurrPos))*temp++=*pCurrPos++;
		CurrTok=VARIABLE;
	}
	else if(*pCurrPos==';')
	{
		CurrTok=PRINT;
	}
	else CurrTok=END;
	*temp=0;
}

double calc_var::proceed()//,  
{
	if (strlen(Function)<1) throw(SyntaxError("No Expression"));
	double t;
	CurrTok=PRINT;
	while (CurrTok!=END)
	{
		t=add_sub();
		if(CurrTok==PRINT)*pCurrPos++;
	}
	return t;//  ,  ;    
}
